SpecialOffers = {}
local knownSales = {}
local isFirstRun = true
local isPlayerWakeUpFromSleep = false

function CheckForRun(isHour)
    if g_sleepManager.isSleeping == true then
        if not isHour then
            do return end
        elseif isPlayerWakeUpFromSleep == true then
            do return end
        elseif isHour then
            isPlayerWakeUpFromSleep = true
            do return end
        end
    end
    if isFirstRun == true then
        isFirstRun = false
        CheckForSales(true)
    elseif isPlayerWakeUpFromSleep == true then
        isPlayerWakeUpFromSleep = false
        CheckForSales(false)
    elseif isHour then
        CheckForSales(false)
    end
end

function CheckForSales(isFirstCheckRun)
    local currentSales = {}
    local triggerSaleNotification = false
    local newSaleItems = 0
    for x=1,20 do
        if g_currentMission.vehicleSaleSystem.items[x] ~= nil then
            table.insert(currentSales, g_currentMission.vehicleSaleSystem.items[x].price .. g_currentMission.vehicleSaleSystem.items[x].age .. g_currentMission.vehicleSaleSystem.items[x].xmlFilename)
        else
            break
        end
    end
    local saleIsKnown = false
    for n in pairs(knownSales) do
        for w in pairs(currentSales) do
            if knownSales[n] == currentSales[w] then
                    saleIsKnown = true
                break
            end
        end
        if saleIsKnown == false then
            table.remove(knownSales,n)
        end
        saleIsKnown = false
    end
    table.sort(knownSales)
    table.sort(currentSales)
    for z in pairs(currentSales) do
        saleIsKnown = false
        for w in pairs(knownSales) do
             if currentSales[z] == knownSales[w] then
                saleIsKnown = true
                break
             end
        end
        if saleIsKnown == false then
            table.insert(knownSales, currentSales[z])
            newSaleItems = newSaleItems + 1
            triggerSaleNotification = true
        end
    end
    if  triggerSaleNotification == true then
        local notifyText = ""
        if newSaleItems == 1 then
            if isFirstCheckRun then
                notifyText = g_i18n:getText("saleinfo_infotext_one_first")
            else
                notifyText = g_i18n:getText("saleinfo_infotext_one")
            end
        else
            if isFirstCheckRun then
                notifyText = string.format(g_i18n:getText("saleinfo_infotext_first"), newSaleItems)
            else
                notifyText = string.format(g_i18n:getText("saleinfo_infotext"), newSaleItems)
            end
        end
        g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_INFO, notifyText)
    end

    currentSales = nil
    return
end

function SpecialOffers:hourChanged()
    CheckForRun(true)
end

function SpecialOffers:minuteChanged()
    CheckForRun(false)
end

g_messageCenter:subscribe(MessageType.HOUR_CHANGED, SpecialOffers.hourChanged)
g_messageCenter:subscribe(MessageType.MINUTE_CHANGED, SpecialOffers.minuteChanged)